import greenfoot.*;  
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Collections;
import java.util.Random;

/**
 * Write a description of class CardWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class CardWorld extends World
{
    int randInt;
    int deal = 0;
    int players = 2;
    int tempCard;
    int round = 1;
    boolean playerTurn1 = true;
    boolean houseTurn;
    boolean roundOver = false;
    boolean startRound = true;
    
    int xPlayerAdd = (getWidth()/8);
    int xHouseAdd = (getWidth()/8);
    int yAdd = (getHeight()/2);

    
    public ArrayList<Integer> house = new ArrayList();
    public ArrayList<Integer> player1 = new ArrayList();
    
    public ArrayList<Integer> houseVal = new ArrayList();
    public ArrayList<Integer> playerVal1 = new ArrayList();
    
    ArrayList<GreenfootImage> images = new ArrayList();
    
    //Creates world, the Deck and the Buttons, and imports the card images through ImageGet().
    public CardWorld()
    {    
        super(800, 600, 1); 
        
        addObject(new Deck(), getWidth()/8, getHeight()/2);
        addObject(new HitButton(), 7*getWidth()/8, (getHeight())/4);
        addObject(new StandButton(), 7*getWidth()/8, (getHeight())/2);
        addObject(new DoubleDownButton(), 7*getWidth()/8, (3*getHeight())/4);
        ImageGet();
    }
    
    //Deals out the first 2 cards to each player.
    public void startHands()
    {
        roundOver = false;
        
        //Essentially alternates the deal between the player and the house,dealing 2 cards to each. Was designed to be adjustable if I wanted to
        //add additional players.
        for (int i = 0; i < (players * 2); i++)
        {
            if (deal % players == 0)
            {
                nextCard();
                changeTurn();
            }
            else if (deal % players == 1)
            {
                nextCard();
                changeTurn();
            }
        }
        
        //sets the game to the players turn.
        playerTurn1 = true;
        houseTurn = false;
    }
    
    public void nextCard()
    {
        //Assign a value to tempCard based on a random value gotten from dealCard() from 1 to 52.
        tempCard = dealCard();
            
        //Checks to make sure the value of tempCard isn't already in one of the hands, and if it is, slects a new value until, there is a card 
        //that hasn't been used. Also intended to be expandable if needed.
        while ((house.contains(tempCard) == true) || (player1.contains(tempCard) == true))
        {
            tempCard = dealCard();
        }
        
        
        //Deals give the card to the players based on whose turn it is.
        if (playerTurn1 == true)
        {
            //Puts the value out of 52 into an ArrayList
            player1.add(tempCard);
            
            //finds the value the card would have in blackjack, nad then adds it to another ArrayList
            if ((tempCard % 13 == 0) || (tempCard % 13 == 12) || (tempCard % 13 == 11))
            {
                playerVal1.add(10);
            }
            else if (tempCard % 13 == 1)
            {
                playerVal1.add(11);
            }
            else
            {
                playerVal1.add(tempCard % 13);
            }
            
            //Creates a Card object in the world, increases the deal count, and has a slight delay.
            addObject(new Card(tempCard), 0 + xPlayerAdd, getHeight()/4 + yAdd);
            xPlayerAdd +=(getWidth()/8);
            deal ++;
            Greenfoot.delay(5);
        }
        //the code here is the same as directly above, just for the house instead of player1.
        else if (houseTurn == true)
        {  
            house.add(tempCard);
            if ((tempCard % 13 == 0) || (tempCard % 13 == 12) || (tempCard % 13 == 11))
            {
                houseVal.add(10);
            }
            else if (tempCard % 13 == 1)
            {
                houseVal.add(11);
            }
            else
            {
                houseVal.add(tempCard % 13);
            }
            addObject(new Card(tempCard), 0 + xHouseAdd, getHeight()/4 );
            xHouseAdd +=(getWidth()/8);
            deal ++;
            Greenfoot.delay(5);
        }
    }
    
    public void changeTurn()
    {
        //Rather self explainitory, changes the turn so that the cards are dealt to the correct player.
        if (playerTurn1 == true)
        {
            playerTurn1 = false;
            houseTurn = true;
        }
        else if (houseTurn == true)
        {
            playerTurn1 = true;
            houseTurn = false;
        }
    }
    
    
    //Deals out the cards to the house after the player is done, then works out the winner for the round.
    //The house stands on a soft 17.
    public void houseDeal()
    {
        while (handSums(houseVal) < 17)
        {
            nextCard();
        }
        roundOver = true;
    }
    
    //Determines all the possibliities of whether the player won the round, then runs the appropriate method. Also creates the button to start the new round.
    public void roundWinner()
    {        
        if (handSums(playerVal1) > 21)
        {
            lose();
        }
        else if (handSums(houseVal) > 21)
        {
            win();
        }
        else if (checkBlackJack(playerVal1) == true)
        {
            playerBlackJack();
            if (checkBlackJack(houseVal) == true)
            {
                houseBlackJack();
                push();
            }
            else
            {
                win();
            }
        }
        else if (checkBlackJack(houseVal) == true)
        {
            houseBlackJack();
            lose();
        }
        else if (handSums(playerVal1) > handSums(houseVal))
        {
            win();
        }
        else if (handSums(houseVal) > handSums(playerVal1))
        {
            lose();
        }
        else if (handSums(houseVal) == handSums(playerVal1))
        {
            push();
        }
        round += 1;
        roundOver = false;
        addObject(new RoundButton(), getWidth()/2, getHeight()/2);
    }
    
    //Tajkes a passed ArrayList, and if it has a total gretaer than 21 and has an ace, changes the Aces value from 11 to 1.
    public void checkAce(ArrayList<Integer> hand)
    {
        if ((handSums(hand) > 21) && (hand.contains(11) == true))
        {
            hand.set(hand.indexOf(11),1);
        }
    }
    
    //Checks if the player's hand total is over 21.
    public boolean checkPlayer()
    {
        while ((handSums(playerVal1) > 21) && (playerVal1.contains(11) == true))
        {
            checkAce(playerVal1);
        }
        
        if (handSums(playerVal1) >= 21)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    //Checks if the house's hand total is over 21, but checks to see if the value of an ace can be changed to one first, then checks again to see if the hand is over 21.
    public boolean checkHouse()
    {
        while ((handSums(houseVal) > 21) && (houseVal.contains(11) == true))
        {
            checkAce(houseVal);
        }
        
        if (handSums(houseVal) >= 21)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    //Allows input of an ArrayList to check if a given hand is a blackjack (Two cards equaling 21).
    public boolean checkBlackJack(ArrayList<Integer> hand)
    {
        if ((hand.size() == 2) && (handSums(hand) == 21))
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    //Runs the notification to announce a player has blackjack.
    public void playerBlackJack()
    {
        System.out.println("You got blackjack");
    }
    
    //Runs to announce that the house has blackjack.
    public void houseBlackJack()
    {
        System.out.println("They got blackjack");
    }
    
    //Runs the notification to announce the player has won the round.
    public void win()
    {
        System.out.println("You Win");
        System.out.println(" ");
        Greenfoot.delay(15);
    }
    
    //Runs the notification to announce the player has lost the round.
    public void lose()
    {
        System.out.println("You Lose");
        System.out.println(" ");
        Greenfoot.delay(15);
    }
    
    //Runs the notification to announce the round was a push (both the player and the house had the same hand).
    public void push()
    {
        System.out.println("Its a Push");
        System.out.println(" ");
        Greenfoot.delay(15);
    }
    
    //Passes the ArrayList images, which contains the 52 images for the different cards.
    public ArrayList GiveImages()
    {
        return images;
    }
    
    //Passes whether the current round has ended, so that other classes can finalize what they are doing.
    public boolean getRoundState()
    {
        return roundOver;
    }
    
    //Passes whether a new round has started, so that Deck() can deal out new cards.
    public boolean getRoundStart()
    {
        return startRound;
    }
    
    //Changes the value of startRound, this is mainly here so that startRound can be changed from Deck().
    public void changeRoundStart()
    {
        startRound = false;
    }
    
    //Clears the various ArrayLists that hold the cards and their values for each player, then clears out the Card() objects, resets nessecary variables, and remove the round button.
    public void clearHands()
    {
        for (int i = (house.size() - 1); i >= 0; i--)
        {
            house.remove(i);
        }
        for (int i = (houseVal.size() - 1); i >= 0; i--)
        {
            houseVal.remove(i);
        }
        for (int i = (player1.size() - 1); i >= 0; i--)
        {
            player1.remove(i);
        }
        for (int i = (playerVal1.size() - 1); i >= 0; i--)
        {
            playerVal1.remove(i);
        }
        List<Card> cards = getObjects(Card.class);
        removeObjects(cards);
        removeObjects(getObjectsAt(getWidth()/2, getHeight()/2,RoundButton.class));
        xPlayerAdd = (getWidth()/8);
        xHouseAdd = (getWidth()/8);
        startRound = true;
        roundOver = false;
    }
    
    //Selects a random value between 1 and 52 for the cards.
    public int dealCard()
    {
        Random generator = new Random();
        
        randInt = (generator.nextInt(52) + 1);
        return randInt;
    }
   
    //adds together the items in the passed ArrayList.
    public int handSums(ArrayList<Integer> hand)
    {
        int sum = 0;
        //add up the cards for the given hand.
        for (int i = 0; i < hand.size(); i++)
        {
            sum +=  hand.get(i);
        }
        return sum;
    }
    
    //Gets the 52 images for the cards and adds them to an ArrayList images.
    public void ImageGet()
    {
        GreenfootImage g = new GreenfootImage("40px-Playing_card_spade_A.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_2.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_3.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_4.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_5.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_6.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_7.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_8.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_9.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_10.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_J.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_Q.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_spade_K.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_A.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_2.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_3.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_4.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_5.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_6.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_7.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_8.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_9.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_10.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_J.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_Q.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_diamond_K.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_A.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_2.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_3.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_4.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_5.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_6.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_7.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_8.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_9.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_10.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_J.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_Q.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_club_K.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_A.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_2.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_3.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_4.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_5.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_6.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_7.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_8.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_9.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_10.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_J.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_Q.svg.png");
        images.add(g);
        
        g = new GreenfootImage("40px-Playing_card_heart_K.svg.png");
        images.add(g);
        
        for (int i = 0; i < images.size(); i++)
        {
            GreenfootImage temp = images.get(i);
            temp.scale(60,75);
        }
    }
}
